﻿-- UAL v4 (open source / modders resource)
-- © 2017/2018 HoT online Team


UAL4 = {};

function UAL4.prerequisitesPresent(specializations)
    return true;
end;

function UAL4:load(savegame)
    self.state = 1;
    self.unloadedShit = 0;
	
	self.triggerAnims = {};
	self.moveTriggerSB = getXMLString(self.xmlFile, "vehicle.moveTriggerSB#animationName");
	table.insert(self.triggerAnims, self.moveTriggerSB);
	self.moveTriggerRB = getXMLString(self.xmlFile, "vehicle.moveTriggerRB#animationName");
	table.insert(self.triggerAnims, self.moveTriggerRB);
	self.moveTrigger155 = getXMLString(self.xmlFile, "vehicle.moveTrigger155#animationName");
	table.insert(self.triggerAnims, self.moveTrigger155);
	self.moveTrigger18 = getXMLString(self.xmlFile, "vehicle.moveTrigger18#animationName");
	table.insert(self.triggerAnims, self.moveTrigger18);
	self.moveTriggerWP = getXMLString(self.xmlFile, "vehicle.moveTriggerWP#animationName");
	table.insert(self.triggerAnims, self.moveTriggerWP);
	self.moveTriggerBB = getXMLString(self.xmlFile, "vehicle.moveTriggerBB#animationName");
	table.insert(self.triggerAnims, self.moveTriggerBB);
	self.moveTriggerBP = getXMLString(self.xmlFile, "vehicle.moveTriggerBP#animationName");
	table.insert(self.triggerAnims, self.moveTriggerBP);
	self.moveTriggerHD = getXMLString(self.xmlFile, "vehicle.moveTriggerHD#animationName");
	table.insert(self.triggerAnims, self.moveTriggerHD);
	
	self.moveTriggerCK = getXMLString(self.xmlFile, "vehicle.moveTriggerCK#animationName");
	
    self.MPCode = SpecializationUtil.callSpecializationsFunction("MPCode");    
    self.checkPlaces = SpecializationUtil.callSpecializationsFunction("checkPlaces");    
    self.checkMinMax = SpecializationUtil.callSpecializationsFunction("checkMinMax");    
    
    self.balesJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#index"));
    self.roundsJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#rounds"));
    self.centerJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#center2"));
    self.woolJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#wool"));
    self.ultimaJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#ultima"));
    self.ultima4Joint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#ultima4"));
    self.hdbalesJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#hdbales"));
	self.bigbalesJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#bigbales"));
	self.wood2Joint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#wood2"));
	self.objectCallbackUAL4 = SpecializationUtil.callSpecializationsFunction("objectCallbackUAL4"); 
	self.objectCallbackChecker = SpecializationUtil.callSpecializationsFunction("objectCallbackChecker"); 
	
	self.checker = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#checker"));
	addTrigger( self.checker, "objectCallbackChecker", self );
		
	self.squareTriggers = {};
	local i=0;
	while true do
		local baseString = string.format("vehicle.triggers.square(%d)#",i);
		local tIndex = getXMLString(self.xmlFile,baseString.."index");
		if tIndex == nil then
			break;
		end;
		local trigger = Utils.indexToObject( self.components, tIndex );
		local entry = {};
        entry.triggerId = trigger;
        entry.count = i+1;
		table.insert(self.squareTriggers, entry);
		addTrigger( trigger, "objectCallbackUAL4", self );
		i=i+1;
	end
	self.roundTriggers = {};
	local i=0;
	while true do
		local baseString = string.format("vehicle.triggers.round(%d)#",i);
		local tIndex = getXMLString(self.xmlFile,baseString.."index");
		if tIndex == nil then
			break;
		end;
		local trigger = Utils.indexToObject( self.components, tIndex );
		local entry = {};
        entry.triggerId = trigger;
        entry.count = i+1;
		table.insert(self.roundTriggers, entry);
		addTrigger( trigger, "objectCallbackUAL4", self );
		i=i+1;
	end
	self.ultima4Triggers = {};
	local i=0;
	while true do
		local baseString = string.format("vehicle.triggers.ultima4(%d)#",i);
		local tIndex = getXMLString(self.xmlFile,baseString.."index");
		if tIndex == nil then
			break;
		end;
		local trigger = Utils.indexToObject( self.components, tIndex );
		local entry = {};
        entry.triggerId = trigger;
        entry.count = i+1;
		table.insert(self.ultima4Triggers, entry);
		addTrigger( trigger, "objectCallbackUAL4", self );
		i=i+1;
	end
	self.ultimaTriggers = {};
	local i=0;
	while true do
		local baseString = string.format("vehicle.triggers.ultima(%d)#",i);
		local tIndex = getXMLString(self.xmlFile,baseString.."index");
		if tIndex == nil then
			break;
		end;
		local trigger = Utils.indexToObject( self.components, tIndex );
		local entry = {};
        entry.triggerId = trigger;
        entry.count = i+1;
		table.insert(self.ultimaTriggers, entry);
		addTrigger( trigger, "objectCallbackUAL4", self );
		i=i+1;
	end
	self.woolTriggers = {};
	local i=0;
	while true do
		local baseString = string.format("vehicle.triggers.wool(%d)#",i);
		local tIndex = getXMLString(self.xmlFile,baseString.."index");
		if tIndex == nil then
			break;
		end;
		local trigger = Utils.indexToObject( self.components, tIndex );
		local entry = {};
        entry.triggerId = trigger;
        entry.count = i+1;
		table.insert(self.woolTriggers, entry);
		addTrigger( trigger, "objectCallbackUAL4", self );
		i=i+1;
	end
	self.bigbaleTriggers = {};
	local i=0;
	while true do
		local baseString = string.format("vehicle.triggers.bigbale(%d)#",i);
		local tIndex = getXMLString(self.xmlFile,baseString.."index");
		if tIndex == nil then
			break;
		end;
		local trigger = Utils.indexToObject( self.components, tIndex );
		local entry = {};
        entry.triggerId = trigger;
        entry.count = i+1;
		table.insert(self.bigbaleTriggers, entry);
		addTrigger( trigger, "objectCallbackUAL4", self );
		i=i+1;
	end
	self.wood2Triggers = {};
	local i=0;
	while true do
		local baseString = string.format("vehicle.triggers.wood2(%d)#",i);
		local tIndex = getXMLString(self.xmlFile,baseString.."index");
		if tIndex == nil then
			break;
		end;
		local trigger = Utils.indexToObject( self.components, tIndex );
		local entry = {};
        entry.triggerId = trigger;
        entry.count = i+1;
		table.insert(self.wood2Triggers, entry);
		addTrigger( trigger, "objectCallbackUAL4", self );
		i=i+1;
	end
	self.hdbaleTriggers = {};
	local i=0;
	while true do
		local baseString = string.format("vehicle.triggers.hdbales(%d)#",i);
		local tIndex = getXMLString(self.xmlFile,baseString.."index");
		if tIndex == nil then
			break;
		end;
		local trigger = Utils.indexToObject( self.components, tIndex );
		local entry = {};
        entry.triggerId = trigger;
        entry.count = i+1;
		table.insert(self.hdbaleTriggers, entry);
		addTrigger( trigger, "objectCallbackUAL4", self );
		i=i+1;
	end

	for i, animation in pairs(self.triggerAnims) do
        self:playAnimation(self.triggerAnims[i], -1, nil, true);
    end;
	self:playAnimation(self.moveTriggerCK, -1, nil, true);	
    
    self.balesToLoad = {};
    self.rbalesToLoad = {};
    self.woolToLoad = {};
    self.ultimaToLoad = {};
    self.ultima4ToLoad = {};
    self.hdbalesToLoad = {};
    self.bigbalesToLoad = {};
	self.wood2ToLoad = {};
    self.balesToMount = {};
    self.rbalesToMount = {};
    self.woolToMount = {};
    self.ultimaToMount = {};
    self.ultima4ToMount = {};
    self.hdbalesToMount = {};
    self.bigbalesToMount = {};
	self.wood2ToMount = {};
    

    self.hayBales = {};
	self.hayBalesHeight = getXMLString(self.xmlFile, "vehicle.hayBales#height");
    local i = 0;
    while true do
        local key = string.format("vehicle.hayBales.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.hayBales, entry);
        end;
        i = i + 1;
    end;
    self.numMaxSquare = i;
    
    self.hayRounds = {};
	self.roundHeight = getXMLString(self.xmlFile, "vehicle.hayRounds#height");
    local i = 0;
    while true do
        local key = string.format("vehicle.hayRounds.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.hayRounds, entry);
        end;
        i = i + 1;
    end;
    self.numMaxRound = i;
    
    self.wool = {};
	self.woolHeight = getXMLString(self.xmlFile, "vehicle.wool#height");
    local i = 0;
    while true do
        local key = string.format("vehicle.wool.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.wool, entry);
        end;
        i = i + 1;
    end;
    self.numMaxWool = i;
    
    self.ultima = {};
	self.ultimaHeight = getXMLString(self.xmlFile, "vehicle.ultima#height");
    local i = 0;
    while true do
        local key = string.format("vehicle.ultima.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.ultima, entry);
        end;
        i = i + 1;
    end;
    self.numMaxUltima = i;
	
	self.ultima4 = {};
	self.ultima4Height = getXMLString(self.xmlFile, "vehicle.ultima4#height");
    local i = 0;
    while true do
        local key = string.format("vehicle.ultima4.bale(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.ultima4, entry);
        end;
        i = i + 1;
    end;
    self.numMaxUltima4 = i;
    
    self.hdbales = {};
	self.hdbalesHeight = getXMLString(self.xmlFile, "vehicle.hdbales#height");
    local i = 0;
    while true do
        local key = string.format("vehicle.hdbales.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.hdbales, entry);
        end;
        i = i + 1;
    end;
    self.numMaxhdbales = i;
	
	self.bigbales = {};
	self.bigbalesHeight = getXMLString(self.xmlFile, "vehicle.bigbales#height");
    local i = 0;
    while true do
        local key = string.format("vehicle.bigbales.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.bigbales, entry);
        end;
        i = i + 1;
    end;
    self.numMaxbigbales = i;
	
	self.wood2 = {};
	self.wood2Height = getXMLString(self.xmlFile, "vehicle.wood2#height");
    local i = 0;
    while true do
        local key = string.format("vehicle.wood2.place(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local entry = {};
        local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
        if index ~= nil then
            entry.node = index;
            entry.baleId = nil;
            table.insert(self.wood2, entry);
        end;
        i = i + 1;
    end;
    self.numMaxWood2 = i;
    
    self.i = {};
    self.workMode = false;
    
    self.counter = 0;
    self.foundIt = false;
    self.baleId = nil;
    
    self.firstTime = true;
    
    self.bales = {};
    
    self.fillLevel = 0;
    self.fillLevelMax = self.numMaxSquare;
    
    self.marker = Utils.indexToObject(self.components,getXMLString(self.xmlFile, "vehicle.marker#index"));
    setVisibility(self.marker, false);
    self.mLeft = Utils.indexToObject(self.components,getXMLString(self.xmlFile, "vehicle.marker#left"));
    self.mRight = Utils.indexToObject(self.components,getXMLString(self.xmlFile, "vehicle.marker#right"));
    self.mBack = Utils.indexToObject(self.components,getXMLString(self.xmlFile, "vehicle.marker#back"));
	self.hLeftX, self.hLeftY, self.hLeftZ = getTranslation(self.mLeft);
	self.hRightX, self.hRightY, self.hRightZ = getTranslation(self.mRight);
	self.hBackX, self.hBackY, self.hBackZ = getTranslation(self.mBack);
    self.unloadPos = 0;
	self.moveAllowed = false;
    
    self.loadTypes = {}
    local loadType = g_i18n:getText("squarebales");    
    if loadType == nil then
        loadType = "squarebales"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
    
	local loadType = g_i18n:getText("roundbales");    
    if loadType == nil then
        loadType = "roundbales"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
    
	local loadType = g_i18n:getText("ultima4");    
    if loadType == nil then
        loadType = "ultima4"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("ultima");    
    if loadType == nil then
        loadType = "ultima"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("woolpallet");    
    if loadType == nil then
        loadType = "woolpallet"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);

	local loadType = g_i18n:getText("bigbales");    
    if loadType == nil then
        loadType = "bigbales"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("wood2pallet");    
    if loadType == nil then
        loadType = "wood2pallet"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);
	
	local loadType = g_i18n:getText("hdbales");    
    if loadType == nil then
        loadType = "hdbales"
    end;
    local entry = {};
    entry.text = loadType;
    table.insert(self.loadTypes, entry);

    
    self.varbodyIDX = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.balesJoint#varBodyIndex"),0);
	
end;

function UAL4:delete()
    for i, balePlace in pairs(self.hayBales) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
    for i, balePlace in pairs(self.hayRounds) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
    for i, balePlace in pairs(self.wool) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
    for i, balePlace in pairs(self.ultima) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	for i, balePlace in pairs(self.ultima4) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
    for i, balePlace in pairs(self.hdbales) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	for i, balePlace in pairs(self.bigbales) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	for i, balePlace in pairs(self.wood2) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                bale:unmount();
            end;
        end;
    end;
	
	for i, triggerNum in pairs(self.squareTriggers) do
        if triggerNum.triggerId ~= nil then
            removeTrigger(triggerNum.triggerId);
        end;
    end;
	for i, triggerNum in pairs(self.roundTriggers) do
        if triggerNum.triggerId ~= nil then
            removeTrigger(triggerNum.triggerId);
        end;
    end;
	for i, triggerNum in pairs(self.ultima4Triggers) do
        if triggerNum.triggerId ~= nil then
            removeTrigger(triggerNum.triggerId);
        end;
    end;
	for i, triggerNum in pairs(self.ultimaTriggers) do
        if triggerNum.triggerId ~= nil then
            removeTrigger(triggerNum.triggerId);
        end;
    end;
	for i, triggerNum in pairs(self.woolTriggers) do
        if triggerNum.triggerId ~= nil then
            removeTrigger(triggerNum.triggerId);
        end;
    end;
	for i, triggerNum in pairs(self.bigbaleTriggers) do
        if triggerNum.triggerId ~= nil then
            removeTrigger(triggerNum.triggerId);
        end;
    end;
	for i, triggerNum in pairs(self.hdbaleTriggers) do
        if triggerNum.triggerId ~= nil then
            removeTrigger(triggerNum.triggerId);
        end;
    end;
	for i, triggerNum in pairs(self.wood2Triggers) do
        if triggerNum.triggerId ~= nil then
            removeTrigger(triggerNum.triggerId);
        end;
    end;
	removeTrigger(self.checker);
end;

function UAL4:mouseEvent(posX, posY, isDown, isUp, button)
end;

function UAL4:keyEvent(unicode, sym, modifier, isDown)
end;

function UAL4:update(dt)
    if self.varbodyIDX ~= 0 and self.varBody ~= nil then
        self.varBodyactIdx = Utils.getNoNil(self.varBody.activeIdx,0);
    else
        self.varBodyactIdx = 0;
    end
    if self.state == 0 then
		self.state = 1
	end
    if self.firstTime then
        self.firstTime = false;
        for k,v in pairs(self.balesToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz, v.fillLevel);
            baleObject:mount(self, self.hayBales[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.baleValueScale = v.baleValueScale;
            end
            if v.wrappingState ~= nil and baleObject.setWrappingState ~= nil then
                baleObject:setWrappingState(v.wrappingState);
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.balesToLoad[k] = nil;
            self.hayBales[k].baleId = v.baleId;
        end;
        for k,v in pairs(self.rbalesToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz, v.fillLevel);
            baleObject:mount(self, self.hayRounds[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.baleValueScale = v.baleValueScale;
            end
            if v.wrappingState ~= nil and baleObject.setWrappingState ~= nil then
                baleObject:setWrappingState(v.wrappingState);
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.rbalesToLoad[k] = nil;
            self.hayRounds[k].baleId = v.baleId;
        end;
        for k,v in pairs(self.woolToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.wool[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.woolToLoad[k] = nil;
            self.wool[k].baleId = v.baleId;
        end;
        for k,v in pairs(self.ultimaToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.ultima[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.ultimaToLoad[k] = nil;
            self.ultima[k].baleId = v.baleId;
        end;
		for k,v in pairs(self.ultima4ToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.ultima4[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.ultima4ToLoad[k] = nil;
            self.ultima4[k].baleId = v.baleId;
        end;
        for k,v in pairs(self.hdbalesToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.hdbales[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.hdbalesToLoad[k] = nil;
            self.hdbales[k].baleId = v.baleId;
        end;
		for k,v in pairs(self.bigbalesToLoad) do
            local baleObject = Bale:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.bigbales[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.bigbalesToLoad[k] = nil;
            self.bigbales[k].baleId = v.baleId;
        end;
        for k,v in pairs(self.wood2ToLoad) do
            local baleObject = FillablePallet:new(self.isServer, self.isClient);
            local x,y,z = unpack(v.translation);
            local rx,ry,rz = unpack(v.rotation);
            baleObject:load(v.filename, x,y,z,rx,ry,rz);
            baleObject:setFillLevel(v.fillLevel, false)
            baleObject:mount(self, self.wood2[k].node, x,y,z, rx,ry,rz);
            if v.baleValueScale ~= nil then
                baleObject.fillablePalletValueScale = v.baleValueScale;
            end
            baleObject:register();
            v.baleId = networkGetObjectId(baleObject);
            self.wood2ToLoad[k] = nil;
            self.wood2[k].baleId = v.baleId;
        end;
		
        for k, baleToMount in pairs(self.balesToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.balesToMount[k] = nil;
            end;
        end;
        for k, baleToMount in pairs(self.rbalesToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.rbalesToMount[k] = nil;
            end;
        end;
        for k, baleToMount in pairs(self.woolToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.woolToMount[k] = nil;
            end;
        end;
        for k, baleToMount in pairs(self.ultimaToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.ultimaToMount[k] = nil;
            end;
        end;
		for k, baleToMount in pairs(self.ultima4ToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.ultima4ToMount[k] = nil;
            end;
        end;
        for k, baleToMount in pairs(self.hdbalesToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.hdbalesToMount[k] = nil;
            end;
        end;
		for k, baleToMount in pairs(self.bigbalesToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.bigbalesToMount[k] = nil;
            end;
        end;
		for k, baleToMount in pairs(self.wood2ToMount) do
            local bale = networkGetObject(baleToMount.serverId);
            if bale ~= nil then
                local x,y,z = unpack(baleToMount.trans);
                local rx,ry,rz = unpack(baleToMount.rot);
                bale:mount(self, baleToMount.linkNode, x,y,z, rx,ry,rz);
                self.wood2ToMount[k] = nil;
            end;
		end;
    end;
	
    if self:getIsActiveForInput() and self:getIsActive() and self.varBodyactIdx == self.varbodyIDX then
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
            if self.counter ~= self.fillLevelMax then
                setVisibility(self.marker, false);
                self.unloadPos = 0;
				self.moveAllowed = false;
                self:MPCode(99, not self.workMode, 0, 0, 0, false);
            end;
        end;

		
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA4) then
            if self.counter == 0 and not self.workMode then
                self.state = self.state + 1;
                --if self.state > 8 then
                if self.state > 7 then
                    self.state = 1;
                end
                self:MPCode(98, false, self.state, 0, 0, false);
            end
        end
        
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
            if self.counter >= 1 and not self.workMode then
                self.unloadPos = self.unloadPos + 1;
				self.moveAllowed = true;
                if self.unloadPos > 0 then
                    self.unloadPos = 0;
					self.moveAllowed = false;
                end

                if self.unloadPos == 0 then
                    setVisibility(self.marker, false);
                    local x,y,z = getTranslation(self.centerJoint)
                    setTranslation(self.marker, x,y,z)
                elseif  self.unloadPos == 1 then
                    setVisibility(self.marker, true);
                    local x,y,z = getTranslation(self.mLeft)
                    setTranslation(self.marker, x,y,z)
                elseif  self.unloadPos == 2 then
                    setVisibility(self.marker, true);
                    local x,y,z = getTranslation(self.mRight)
                    setTranslation(self.marker, x,y,z)
                elseif  self.unloadPos == 3 then
                    setVisibility(self.marker, true);
                    local x,y,z = getTranslation(self.mBack)
                    setTranslation(self.marker, x,y,z)
                end;
            end;
        end
		
		if self.moveAllowed then
			local moveSpeed = 0.05;
			local xAttacher, yAttacher, zAttacher = getTranslation(self.mBack);
			if InputBinding.isPressed(InputBinding.UALUP) then
				yAttacher = yAttacher + moveSpeed;
			elseif InputBinding.isPressed(InputBinding.UALDOWN) then
				yAttacher = yAttacher - moveSpeed;
			elseif InputBinding.isPressed(InputBinding.UALLEFT) then
				xAttacher = xAttacher + moveSpeed;
			elseif InputBinding.isPressed(InputBinding.UALRIGHT) then
				xAttacher = xAttacher - moveSpeed;
			elseif InputBinding.isPressed(InputBinding.UALHOME) then
				yAttacher = self.hBackY;
				xAttacher = self.hBackX;
			end;
			setTranslation(self.mBack, xAttacher, yAttacher, self.hBackZ);
			setTranslation(self.mLeft, self.hLeftX+xAttacher, yAttacher, self.hLeftZ);
			setTranslation(self.mRight, self.hRightX+xAttacher, yAttacher, self.hRightZ);
            if  self.unloadPos == 1 then
                setTranslation(self.marker, getTranslation(self.mLeft))
            elseif  self.unloadPos == 2 then
                setTranslation(self.marker, getTranslation(self.mRight))
            elseif  self.unloadPos == 3 then
                setTranslation(self.marker, getTranslation(self.mBack))
            end;
		end
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
            if self.counter >= 1 and not self.workMode then
				local aAttacher, bAttacher, cAttacher = getTranslation(self.mBack);
				self:MPCode(24, false, self.unloadPos, bAttacher, aAttacher, false);
            end;
        end;
    end;
    
    if self.varBodyactIdx ~= self.varbodyIDX and self.workMode then
		self:MPCode(99, false, 0, 0, 0, false);
    end;
end;

function UAL4:draw()
    if self.varBodyactIdx == self.varbodyIDX then

        if self.counter < self.fillLevelMax then
            if not self.workMode then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE_on"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
            else
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE_off"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
            end;
        end;
        
        if self.counter >= 1 and not self.workMode then
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
            if self.unloadPos == 0 then
                --g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD_C"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
            elseif self.unloadPos == 1 then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD_L"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALUPDOWN"), self.typeDesc), InputBinding.UALUPDOWN);
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALLEFTRIGHT"), self.typeDesc), InputBinding.UALLEFTRIGHT);
            elseif self.unloadPos == 2 then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD_R"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALUPDOWN"), self.typeDesc), InputBinding.UALUPDOWN);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALLEFTRIGHT"), self.typeDesc), InputBinding.UALLEFTRIGHT);
            elseif self.unloadPos == 3 then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD_B"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALUPDOWN"), self.typeDesc), InputBinding.UALUPDOWN);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("input_UALLEFTRIGHT"), self.typeDesc), InputBinding.UALLEFTRIGHT);
            end;
        end;
    
        if self.counter == 0 and not self.workMode then
            g_currentMission:addHelpButtonText(string.format(self.loadTypes[self.state].text, self.typeDesc), InputBinding.IMPLEMENT_EXTRA4);
        end;
    end;
end;

function UAL4:MPCode(mode, bool, state, dif, olddif, noEventSend)
    MPEvent.sendEvent(self, mode, bool, state, dif, olddif, noEventSend);
    if mode == 21 then    
        
        self.baleId = dif;
		self.selectedBalePlace = olddif;
        local object = networkGetObject(self.baleId);
        if object == nil then
            return;
        end;
		if self.counter >= self.fillLevelMax then
			return;
        end;
		
        self.counter = self.counter + 1;        
        self.fillLevel = self.counter;

        if state==1 then
            object:mount(self, self.hayBales[self.selectedBalePlace].node, 0,0,0, 0,0,0);
            self.hayBales[self.selectedBalePlace].baleId = self.baleId;
        elseif state==2 then
            object:mount(self, self.hayRounds[self.selectedBalePlace].node, 0,0,0, 0,0,0);
            self.hayRounds[self.selectedBalePlace].baleId = self.baleId;
        elseif state==3 then
            object:mount(self, self.ultima4[self.selectedBalePlace].node, 0,0,0, 0,0,0);
            self.ultima4[self.selectedBalePlace].baleId = self.baleId;
		elseif state==4 then
            object:mount(self, self.ultima[self.selectedBalePlace].node, 0,0,0, 0,0,0);
            self.ultima[self.selectedBalePlace].baleId = self.baleId;
		elseif state==5 then
            object:mount(self, self.wool[self.selectedBalePlace].node, 0,0,0, 0,0,0);
            self.wool[self.selectedBalePlace].baleId = self.baleId;
		elseif state==6 then
            object:mount(self, self.bigbales[self.selectedBalePlace].node, 0,0,0, 0,0,0);
            self.bigbales[self.selectedBalePlace].baleId = self.baleId;
		elseif state==7 then
			object:mount(self, self.wood2[self.selectedBalePlace].node, 0,0,0, 0,0,0);
            self.wood2[self.selectedBalePlace].baleId = self.baleId;
		elseif state==8 then
            object:mount(self, self.hdbales[self.selectedBalePlace].node, 0,0,0, 0,0,0);
            self.hdbales[self.selectedBalePlace].baleId = self.baleId;
        end;
        
        self.fillLevelMax = self.numMaxSquare;
        if state == 2 then
            self.fillLevelMax = self.numMaxRound;
        end
		if state == 3 then
            self.fillLevelMax = self.numMaxUltima4;
        end
		if state == 4 then
            self.fillLevelMax = self.numMaxUltima;
        end
        if state == 5 then
            self.fillLevelMax = self.numMaxWool;
        end
        if state == 6 then
            self.fillLevelMax = self.numMaxbigbales;
        end
		if state == 7 then
            self.fillLevelMax = self.numMaxWood2;
        end
        if state == 8 then
            self.fillLevelMax = self.numMaxhdbales;
        end
		self.capacity = self.fillLevelMax;
        
        self.foundIt = false;
        self.baleId = nil;

    elseif mode == 24 then
        
        if state == 0 then
            local x,y,z = getTranslation(self.centerJoint)
            setTranslation(self.balesJoint, x,y,z)
            setTranslation(self.roundsJoint, x,y,z)
            setTranslation(self.woolJoint, x,y,z)
            setTranslation(self.ultimaJoint, x,y,z)
            setTranslation(self.ultima4Joint, x,y,z)
            setTranslation(self.hdbalesJoint, x,y,z)
            setTranslation(self.bigbalesJoint, x,y,z)
			setTranslation(self.wood2Joint, x,y,z)
        elseif state == 1 then
            local x,y,z = getTranslation(self.mLeft)
            setTranslation(self.balesJoint, self.hLeftX+olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, self.hLeftX+olddif,dif-1.1,z)
            setTranslation(self.woolJoint, self.hLeftX+olddif,dif-1.1,z)
            setTranslation(self.ultimaJoint, self.hLeftX+olddif,dif-1.1,z)
            setTranslation(self.ultima4Joint, self.hLeftX+olddif,dif-1.1,z)
            setTranslation(self.hdbalesJoint, self.hLeftX+olddif,dif-1.1,z)
            setTranslation(self.bigbalesJoint, self.hLeftX+olddif,dif-1.1,z)
			setTranslation(self.wood2Joint, self.hLeftX+olddif,dif-1.1,z)
        elseif state == 2 then
            local x,y,z = getTranslation(self.mRight)
            setTranslation(self.balesJoint, self.hRightX+olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, self.hRightX+olddif,dif-1.1,z)
            setTranslation(self.woolJoint, self.hRightX+olddif,dif-1.1,z)
            setTranslation(self.ultimaJoint, self.hRightX+olddif,dif-1.1,z)
            setTranslation(self.ultima4Joint, self.hRightX+olddif,dif-1.1,z)
            setTranslation(self.hdbalesJoint, self.hRightX+olddif,dif-1.1,z)
            setTranslation(self.bigbalesJoint, self.hRightX+olddif,dif-1.1,z)
			setTranslation(self.wood2Joint, self.hRightX+olddif,dif-1.1,z)
        elseif state == 3 then
            local x,y,z = getTranslation(self.mBack)
            setTranslation(self.balesJoint, olddif,dif-1.1,z)
            setTranslation(self.roundsJoint, olddif,dif-1.1,z)
            setTranslation(self.woolJoint, olddif,dif-1.1,z)
            setTranslation(self.ultimaJoint, olddif,dif-1.1,z)
            setTranslation(self.ultima4Joint, olddif,dif-1.1,z)
            setTranslation(self.hdbalesJoint, olddif,dif-1.1,z)
            setTranslation(self.bigbalesJoint, olddif,dif-1.1,z)
			setTranslation(self.wood2Joint, olddif,dif-1.1,z)
        end
        
        for _, balePlace in pairs(self.hayBales) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
					self.unloadedShit = self.unloadedShit + 1;
                end;
                balePlace.baleId = nil;
            end;
        end;
    
        for _, balePlace in pairs(self.hayRounds) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
					self.unloadedShit = self.unloadedShit + 1;
                end;
                balePlace.baleId = nil;
            end;
        end;
        for _, balePlace in pairs(self.wool) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
					self.unloadedShit = self.unloadedShit + 1;
                end;
                balePlace.baleId = nil;
            end;
        end;
        for _, balePlace in pairs(self.ultima) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
					self.unloadedShit = self.unloadedShit + 1;
                end;
                balePlace.baleId = nil;
            end;
        end;
		for _, balePlace in pairs(self.ultima4) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
					self.unloadedShit = self.unloadedShit + 1;
                end;
                balePlace.baleId = nil;
            end;
        end;
        for _, balePlace in pairs(self.hdbales) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
					self.unloadedShit = self.unloadedShit + 1;
                end;
                balePlace.baleId = nil;
            end;
        end;
		for _, balePlace in pairs(self.bigbales) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
					self.unloadedShit = self.unloadedShit + 1;
                end;
                balePlace.baleId = nil;
            end;
        end;
		for _, balePlace in pairs(self.wood2) do
            if balePlace.baleId ~= nil then
                local baleServerId = balePlace.baleId
                local bale = networkGetObject(baleServerId);
                if bale ~= nil then
                    bale:unmount();
					self.unloadedShit = self.unloadedShit + 1;
                end;
                balePlace.baleId = nil;
            end;
        end;
		
        self.counter = 0;
        self.fillLevel = 0;

        setVisibility(self.marker, false);
        local x,y,z = getTranslation(self.centerJoint)
        setTranslation(self.marker, x,y,z)
        self.unloadPos = 0;
		self.moveAllowed = false;
        local x,y,z = getTranslation(self.centerJoint)
        setTranslation(self.balesJoint, x,y,z)
        setTranslation(self.roundsJoint, x,y,z)
        setTranslation(self.woolJoint, x,y,z)
        setTranslation(self.ultimaJoint, x,y,z)
        setTranslation(self.ultima4Joint, x,y,z)
        setTranslation(self.hdbalesJoint, x,y,z)
        setTranslation(self.bigbalesJoint, x,y,z)
		setTranslation(self.wood2Joint, x,y,z)
		
		setTranslation(self.mBack, self.hBackX, self.hBackY, self.hBackZ);
		setTranslation(self.mLeft, self.hLeftX, self.hLeftY, self.hLeftZ);
		setTranslation(self.mRight, self.hRightX, self.hRightY, self.hRightZ);
        
    elseif mode == 98 then
        self.state = state;
        
    elseif mode == 99 then
        self.workMode = bool;
		if self.workMode then
			--self:playAnimation(self.moveTriggerUp, 1, nil, true);
			self:playAnimation(self.triggerAnims[self.state], 1, nil, true);
			self:playAnimation(self.moveTriggerCK, -1, nil, true);
		else
			--self:playAnimation(self.moveTriggerUp, -1, nil, true);
			self:playAnimation(self.triggerAnims[self.state], -1, nil, true);
			local aAttacher, bAttacher, cAttacher = getTranslation(self.mBack);
			self:MPCode(24, false, self.unloadPos, bAttacher, aAttacher, false);
			self:playAnimation(self.moveTriggerCK, 1, nil, true);
		end
    end;
end;

function UAL4:updateTick(dt)
end;

function UAL4:postLoad(savegame)
	if savegame == nil or savegame.resetVehicles then
		return
	end
	
	local key = savegame.key
    self.counter = Utils.getNoNil(getXMLInt(savegame.xmlFile, key.."#numBales"),0);
    self.state = Utils.getNoNil(getXMLInt(savegame.xmlFile, key.."#baleMode"),0);
    self.fillLevel = self.counter;
    self.capacity = self.numMaxSquare;
    if self.state == 2 then
        self.capacity = self.numMaxRound;
    end
	if self.state == 3 then
        self.capacity = self.numMaxUltima4;
    end
	if self.state == 4 then
        self.capacity = self.numMaxUltima;
    end
    if self.state == 5 then
        self.capacity = self.numMaxWool;
    end
	if self.state == 6 then
        self.capacity = self.numMaxbigbales;
    end
	if self.state == 7 then
        self.capacity = self.numMaxWood2;
    end
    if self.state == 8 then
        self.capacity = self.numMaxhdbales;
    end
    if self.varbodyIDX ~= 0 and self.varBody ~= nil then
        self.varBodyactIdx = Utils.getNoNil(self.varBody.activeIdx,0);
    else
        self.varBodyactIdx = 0;
    end
    if self.varbodyIDX ~= self.varBodyactIdx then
        self.capacity = self.varBody.nodes[self.varBodyactIdx].capacity;
    end
    self.fillLevelMax = self.capacity;
        
    local i=0;
    while true do
        local baleKey = key..string.format(".bale(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, bale "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.hayBales) then
                    parentNode = self.hayBales[balePlace].node;
                    bales = self.hayBales[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.balesToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;
        
    local i=0;
    while true do
        local baleKey = key..string.format(".rbale(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, rbale "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.hayRounds) then
                    parentNode = self.hayRounds[balePlace].node;
                    bales = self.hayRounds[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.rbalesToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;
    
    local i=0;
    while true do
        local baleKey = key..string.format(".wool(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, wool "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.wool) then
                    parentNode = self.wool[balePlace].node;
                    bales = self.wool[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.woolToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;

    local i=0;
    while true do
        local baleKey = key..string.format(".ultima(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, ultima "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.ultima) then
                    parentNode = self.ultima[balePlace].node;
                    bales = self.ultima[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.ultimaToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;

	local i=0;
    while true do
        local baleKey = key..string.format(".ultima4(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, ultima4 "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.ultima4) then
                    parentNode = self.ultima4[balePlace].node;
                    bales = self.ultima4[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.ultima4ToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;

    local i=0;
    while true do
        local baleKey = key..string.format(".hdbales(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, hdbales "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.hdbales) then
                    parentNode = self.hdbales[balePlace].node;
                    bales = self.hdbales[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.hdbalesToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;
	
	local i=0;
    while true do
        local baleKey = key..string.format(".bigbales(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, bigbales "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.bigbales) then
                    parentNode = self.bigbales[balePlace].node;
                    bales = self.bigbales[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.bigbalesToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;
    
	local i=0;
    while true do
        local baleKey = key..string.format(".wood2(%d)", i);
        if not hasXMLProperty(savegame.xmlFile, baleKey) then
            break;
        end;
        local filename = getXMLString(savegame.xmlFile, baleKey.."#filename");
        if filename ~= nil then
            filename = Utils.convertFromNetworkFilename(filename);
            local x,y,z = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#position"));
            local xRot,yRot,zRot = Utils.getVectorFromString(getXMLString(savegame.xmlFile, baleKey.."#rotation"));
            local fillLevel = getXMLFloat(savegame.xmlFile, baleKey.."#fillLevel");
            local balePlace = getXMLInt(savegame.xmlFile, baleKey.."#balePlace");
            local helper = getXMLInt(savegame.xmlFile, baleKey.."#helper");
            if balePlace == nil or (balePlace > 0 and (x == nil or y == nil or z == nil or xRot == nil or yRot == nil or zRot == nil)) or (balePlace < 1 and helper == nil) then
                print("Warning: Corrupt savegame, wood2 "..filename.." could not be loaded");
            else
                local translation;
                local rotation;
                if balePlace > 0 then
                    translation = {x,y,z};
                    rotation={xRot, yRot, zRot};
                else
                    translation = {0,0,0};
                    rotation={0,0,0};
                end;
                local parentNode = nil;
                local bales = nil;
                if balePlace < 1 then
                    
                elseif balePlace <= table.getn(self.wood2) then
                    parentNode = self.wood2[balePlace].node;
                    bales = self.wood2[balePlace].baleId;
                end;
                if parentNode ~= nil then
                    local baleValueScale = getXMLFloat(savegame.xmlFile, baleKey.."#baleValueScale");
                    local wrappingState = getXMLFloat(savegame.xmlFile, baleKey.."#wrappingState");
                    table.insert(self.wood2ToLoad, {parentNode=parentNode, filename=filename, bales=bales, translation=translation, rotation=rotation, fillLevel=fillLevel, baleValueScale=baleValueScale, wrappingState=wrappingState});
                end;
            end;
        end;
        i = i +1;
    end;
	
    return BaseMission.VEHICLE_LOAD_OK;
end;

function UAL4:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'numBales="'..tostring(self.counter)..'"'..' baleMode="'..tostring(self.state)..'"';
    local nodes = "";
    local baleNum = 0;
    
    for i, balePlace in pairs(self.hayBales) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<bale filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
    
    local baleNum = 0;
    for i, balePlace in pairs(self.hayRounds) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<rbale filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
    
    local baleNum = 0;
    for i, balePlace in pairs(self.wool) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<wool filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;

    local baleNum = 0;
    for i, balePlace in pairs(self.ultima) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<ultima filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
    
	local baleNum = 0;
    for i, balePlace in pairs(self.ultima4) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<ultima4 filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
	
    local baleNum = 0;
    for i, balePlace in pairs(self.hdbales) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<hdbales filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
	
	local baleNum = 0;
    for i, balePlace in pairs(self.bigbales) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<bigbales filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;

	local baleNum = 0;
    for i, balePlace in pairs(self.wood2) do
        if balePlace.baleId ~= nil then
            local bale = networkGetObject(balePlace.baleId);
            if bale ~= nil then
                local nodeId = bale.nodeId;
                local x,y,z = getTranslation(nodeId);
                local rx,ry,rz = getRotation(nodeId);
                if baleNum>0 then
                    nodes = nodes.."\n";
                end;
                local wrappingState = Utils.getNoNil(bale.wrappingState, 0);
                local baleValueScale = Utils.getNoNil(bale.baleValueScale, 1);
                nodes = nodes..nodeIdent..'<wood2 filename="'..Utils.encodeToHTML(Utils.convertToNetworkFilename(bale.i3dFilename))..'" fillLevel="'..bale:getFillLevel()..'" position="'..x..' '..y..' '..z..'" rotation="'..rx..' '..ry..' '..rz..'" wrappingState="'..wrappingState..'" baleValueScale="'..baleValueScale..'" balePlace="'..i..'" />';
                baleNum = baleNum+1;
            end;
        end;
    end;
	
    return attributes,nodes;
end;

function UAL4:readStream(streamId, connection)
    self.workMode = streamReadBool(streamId);
    self.counter = streamReadInt32(streamId);
    
    self.fillLevel = streamReadFloat32(streamId);
    self.state = streamReadInt32(streamId);
    
	for i=1, table.getn(self.hayBales) do
        local baleServerId = streamReadFloat32(streamId);
        if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.hayBales[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.balesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.hayBales[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
    for i=1, table.getn(self.hayRounds) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.hayRounds[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.rbalesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.hayRounds[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
    for i=1, table.getn(self.wool) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.wool[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.woolToMount[baleServerId] = {serverId=baleServerId, linkNode=self.wool[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
    for i=1, table.getn(self.ultima) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.ultima[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.ultimaToMount[baleServerId] = {serverId=baleServerId, linkNode=self.ultima[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	for i=1, table.getn(self.ultima4) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.ultima4[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.ultima4ToMount[baleServerId] = {serverId=baleServerId, linkNode=self.ultima4[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
    for i=1, table.getn(self.hdbales) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.hdbales[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.hdbalesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.hdbales[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	for i=1, table.getn(self.bigbales) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.bigbales[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.bigbalesToMount[baleServerId] = {serverId=baleServerId, linkNode=self.bigbales[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
	for i=1, table.getn(self.wood2) do
        local baleServerId = streamReadFloat32(streamId);
		if baleServerId == 4711 then
			baleServerId = nil;
		end
        self.wood2[i].baleId = baleServerId;
		if baleServerId ~= nil then
			self.wood2ToMount[baleServerId] = {serverId=baleServerId, linkNode=self.wood2[i].node, trans={ 0,0,0}, rot={0,0,0} };
		end
    end;
end;

function UAL4:writeStream(streamId, connection)

    streamWriteBool(streamId, self.workMode);
    streamWriteInt32(streamId, self.counter);

    streamWriteFloat32(streamId, self.fillLevel);
    streamWriteInt32(streamId, self.state);
    
    for i=1, table.getn(self.hayBales) do
        local baleServerId = Utils.getNoNil(self.hayBales[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
    for i=1, table.getn(self.hayRounds) do
		local baleServerId = Utils.getNoNil(self.hayRounds[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
    for i=1, table.getn(self.wool) do
		local baleServerId = Utils.getNoNil(self.wool[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
    for i=1, table.getn(self.ultima) do
		local baleServerId = Utils.getNoNil(self.ultima[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	for i=1, table.getn(self.ultima4) do
		local baleServerId = Utils.getNoNil(self.ultima4[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
    for i=1, table.getn(self.hdbales) do
		local baleServerId = Utils.getNoNil(self.hdbales[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	for i=1, table.getn(self.bigbales) do
		local baleServerId = Utils.getNoNil(self.bigbales[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
	for i=1, table.getn(self.wood2) do
		local baleServerId = Utils.getNoNil(self.wood2[i].baleId, 4711);
        streamWriteFloat32(streamId, baleServerId);
    end;
end;
function UAL4:objectCallbackChecker(triggerId, otherId, onEnter, onLeave, onStay)
	self:playAnimation(self.moveTriggerCK, -1, nil, true);
	if self.workMode then
		for _, belt in pairs(self.tensionBelts.sortedBelts) do
			self:setTensionBeltsActive(not self.workMode, belt.id, false)
		end
	else
		if self.unloadedShit > 0 then
			for _, belt in pairs(self.tensionBelts.sortedBelts) do
				self:setTensionBeltsActive(not self.workMode, belt.id, false)
			end
			self.unloadedShit = 0;
		end
	end
end
function UAL4:objectCallbackUAL4(triggerId, otherId, onEnter, onLeave, onStay)
	self:checkMinMax(triggerId)
	
	if onEnter and self.workMode then
		local object = g_currentMission:getNodeObject(otherId);
		if object == nil or object.mountObject ~= nil then
			return
		end
		if self.counter >= self.fillLevelMax then
			return
		end
		
		if self.isServer and (object:isa(Bale) or object:isa(FillablePallet)) then
			self.foundIt = false;
			local baleDiameter = tonumber(getUserAttribute(object.nodeId, "baleDiameter"));
			local isRoundbale = Utils.getNoNil(getUserAttribute(object.nodeId, "isRoundbale"), false);
			local isHDbale = Utils.getNoNil(getUserAttribute(object.nodeId, "isHDbale"), false);
			if not isHDbale then
				isHDbale = (Utils.getNoNil(getUserAttribute(object.nodeId, "size"), 0) == 493612);
			end
			local isBigBale = Utils.getNoNil(getUserAttribute(object.nodeId, "isBigBale"), false);
			if not isBigBale then
				isBigBale = (Utils.getNoNil(getUserAttribute(object.nodeId, "size"), 0) == 121324);
			end
			
			if baleDiameter == nil then
				local baleDiameter = 0;
			end
    
			self.baleId = nil;
			if (self.state == 1 and not isRoundbale and not isHDbale and not isBigBale and (object:isa(Bale))) or
			(self.state == 2 and isRoundbale and baleDiameter <= 1.3) or
			(self.state == 3 and isRoundbale and baleDiameter > 1.3 and baleDiameter <= 1.55) or
			(self.state == 4 and isRoundbale and baleDiameter > 1.55 and baleDiameter <= 1.8) or
			(self.state == 5 and object:isa(FillablePallet)) or 
			(self.state == 6 and isBigBale) or
			(self.state == 7 and object:isa(FillablePallet)) or
			(self.state == 8 and isHDbale) then
				self.foundIt = true;
				self.baleId = networkGetObjectId(object);
				self.foundPlace = false;
				self.validBalePlace = 0;
				self:checkPlaces(self.minPosition, self.maxPosition)
				if self.foundPlace then
					self:MPCode(21, false, self.state, self.baleId, self.validBalePlace, false);
					if self.counter == self.fillLevelMax then
						self:MPCode(99, false, 0, 0, 0, false);
					end;
				end;
			end;

		end
	end;
end;

function UAL4:checkMinMax(triggerId)
	if self.state == 1 then
		for i=1, table.getn(self.squareTriggers) do
			if triggerId == self.squareTriggers[i].triggerId then
				self.triggerNumber = self.squareTriggers[i].count;
				self.maxPosition = self.triggerNumber * self.hayBalesHeight;
				self.minPosition = self.maxPosition - (self.hayBalesHeight-1)
				break
			end
		end;
	elseif self.state == 2 then
		for i=1, table.getn(self.roundTriggers) do
			if triggerId == self.roundTriggers[i].triggerId then
				self.triggerNumber = self.roundTriggers[i].count;
				self.maxPosition = self.triggerNumber * self.roundHeight;
				self.minPosition = self.maxPosition - (self.roundHeight-1)
				break
			end
		end;
	elseif self.state == 3 then
		for i=1, table.getn(self.ultima4Triggers) do
			if triggerId == self.ultima4Triggers[i].triggerId then
				self.triggerNumber = self.ultima4Triggers[i].count;
				self.maxPosition = self.triggerNumber * self.ultima4Height;
				self.minPosition = self.maxPosition - (self.ultima4Height-1)
				break
			end
		end;
	elseif self.state == 4 then
		for i=1, table.getn(self.ultimaTriggers) do
			if triggerId == self.ultimaTriggers[i].triggerId then
				self.triggerNumber = self.ultimaTriggers[i].count;
				self.maxPosition = self.triggerNumber * self.ultimaHeight;
				self.minPosition = self.maxPosition - (self.ultimaHeight-1)
				break
			end
		end;
	elseif self.state == 5 then
		for i=1, table.getn(self.woolTriggers) do
			if triggerId == self.woolTriggers[i].triggerId then
				self.triggerNumber = self.woolTriggers[i].count;
				self.maxPosition = self.triggerNumber * self.woolHeight;
				self.minPosition = self.maxPosition - (self.woolHeight-1)
				break
			end
		end;
	elseif self.state == 6 then
		for i=1, table.getn(self.bigbaleTriggers) do
			if triggerId == self.bigbaleTriggers[i].triggerId then
				self.triggerNumber = self.bigbaleTriggers[i].count;
				self.maxPosition = self.triggerNumber * self.bigbalesHeight;
				self.minPosition = self.maxPosition - (self.bigbalesHeight-1)
				break
			end
		end;
	elseif self.state == 7 then
		for i=1, table.getn(self.wood2Triggers) do
			if triggerId == self.wood2Triggers[i].triggerId then
				self.triggerNumber = self.wood2Triggers[i].count;
				self.maxPosition = self.triggerNumber * self.wood2Height;
				self.minPosition = self.maxPosition - (self.wood2Height-1)
				break
			end
		end;
	elseif self.state == 8 then
		for i=1, table.getn(self.hdbaleTriggers) do
			if triggerId == self.hdbaleTriggers[i].triggerId then
				self.triggerNumber = self.hdbaleTriggers[i].count;
				self.maxPosition = self.triggerNumber * self.hdbalesHeight;
				self.minPosition = self.maxPosition - (self.hdbalesHeight-1)
				break
			end
		end;
	end;
end;

function UAL4:checkPlaces(minPos, maxPos)
	if self.state == 1 then
		for i = tonumber(minPos), tonumber(maxPos) do
			if self.hayBales[i].baleId == nil then
				self.foundPlace = true;
				self.validBalePlace = i;
				return
			end
		end
	elseif self.state == 2 then
		for i = tonumber(minPos), tonumber(maxPos) do
			if self.hayRounds[i].baleId == nil then
				self.foundPlace = true;
				self.validBalePlace = i;
				return
			end
		end
	elseif self.state == 3 then
		for i = tonumber(minPos), tonumber(maxPos) do
			if self.ultima4[i].baleId == nil then
				self.foundPlace = true;
				self.validBalePlace = i;
				return
			end
		end
	elseif self.state == 4 then
		for i = tonumber(minPos), tonumber(maxPos) do
			if self.ultima[i].baleId == nil then
				self.foundPlace = true;
				self.validBalePlace = i;
				return
			end
		end
	elseif self.state == 5 then
		for i = tonumber(minPos), tonumber(maxPos) do
			if self.wool[i].baleId == nil then
				self.foundPlace = true;
				self.validBalePlace = i;
				return
			end
		end
	elseif self.state == 6 then
		for i = tonumber(minPos), tonumber(maxPos) do
			if self.bigbales[i].baleId == nil then
				self.foundPlace = true;
				self.validBalePlace = i;
				return
			end
		end
	elseif self.state == 7 then
		for i = tonumber(minPos), tonumber(maxPos) do
			if self.wood2[i].baleId == nil then
				self.foundPlace = true;
				self.validBalePlace = i;
				return
			end
		end
	elseif self.state == 8 then
		for i = tonumber(minPos), tonumber(maxPos) do
			if self.hdbales[i].baleId == nil then
				self.foundPlace = true;
				self.validBalePlace = i;
				return
			end
		end
	end
end;